 package com.huimv.acquisition.controller;

import java.util.Arrays;
import java.util.Map;

import com.huimv.acquisition.entity.DeviceSendMessageAlarmEntity;
import com.huimv.acquisition.result.R;
import com.huimv.acquisition.service.DeviceSendMessageAlarmService;
import com.huimv.acquisition.utils.PageUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;




/**
 * 
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-08-05 21:54:09
 */
@RestController
@RequestMapping("management/devicesendmessagealarm")
public class DeviceSendMessageAlarmController {
    @Autowired
    private DeviceSendMessageAlarmService deviceSendMessageAlarmService;

    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = deviceSendMessageAlarmService.queryPage(params);

        return R.ok().put("page", page);
    }


    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		DeviceSendMessageAlarmEntity deviceSendMessageAlarm = deviceSendMessageAlarmService.getById(id);

        return R.ok().put("deviceSendMessageAlarm", deviceSendMessageAlarm);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody DeviceSendMessageAlarmEntity deviceSendMessageAlarm){
		deviceSendMessageAlarmService.save(deviceSendMessageAlarm);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody DeviceSendMessageAlarmEntity deviceSendMessageAlarm){
		deviceSendMessageAlarmService.updateById(deviceSendMessageAlarm);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		deviceSendMessageAlarmService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }

}
