 package com.huimv.acquisition.controller;

import java.util.Arrays;
import java.util.Map;

import com.huimv.acquisition.entity.EnvTempAlarmEntity;
import com.huimv.acquisition.result.R;
import com.huimv.acquisition.service.EnvTempAlarmService;
import com.huimv.acquisition.utils.PageUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;



/**
 * 
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-08-05 21:54:09
 */
@RestController
@RequestMapping("management/envtempalarm")
public class EnvTempAlarmController {
    @Autowired
    private EnvTempAlarmService envTempAlarmService;

    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = envTempAlarmService.queryPage(params);

        return R.ok().put("page", page);
    }


    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		EnvTempAlarmEntity envTempAlarm = envTempAlarmService.getById(id);

        return R.ok().put("envTempAlarm", envTempAlarm);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody EnvTempAlarmEntity envTempAlarm){
		envTempAlarmService.save(envTempAlarm);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody EnvTempAlarmEntity envTempAlarm){
		envTempAlarmService.updateById(envTempAlarm);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		envTempAlarmService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }

}
