 package com.huimv.acquisition.controller;

import java.util.Arrays;
import java.util.Map;

import com.huimv.acquisition.entity.FarmStockEntity;
import com.huimv.acquisition.result.R;
import com.huimv.acquisition.service.FarmStockService;
import com.huimv.acquisition.utils.PageUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;


/**
 * 
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-08-04 14:13:15
 */
@RestController
@RequestMapping("management/farmstock")
public class FarmStockController {
    @Autowired
    private FarmStockService farmStockService;

    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = farmStockService.queryPage(params);

        return R.ok().put("page", page);
    }


    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		FarmStockEntity farmStock = farmStockService.getById(id);

        return R.ok().put("farmStock", farmStock);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody FarmStockEntity farmStock){
		farmStockService.save(farmStock);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody FarmStockEntity farmStock){
		farmStockService.updateById(farmStock);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		farmStockService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }

}
