package com.huimv.acquisition.socket.eartagrecive.service.impl;


import com.huimv.acquisition.socket.eartagrecive.service.IClientDataPacketService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.ParseException;

/**
 * @Project : huimv.ql
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/

@Service
@Slf4j
public class ClientDataPacketServiceImpl implements IClientDataPacketService {

    @Autowired
    private ReceivePackageSerivce receivePackageSerivce;

    @Autowired
    private SendPackageService sendPackageService;

    //现在没有判断了，数据直接处理.上传的数据单一，只有耳标数据
    @Override
    public String handleClientSendPacket(String clientMessageTxt) throws ParseException {
        if (clientMessageTxt == null || clientMessageTxt.isEmpty()) {
            log.error("本地提交数据包为空.");
            return  "null"    ;
        }
        String matcher = "[+]";
        String[] clientMessageArray = clientMessageTxt.split(matcher);
        String cmd = clientMessageArray[2];
        String  codHead = clientMessageArray[0];  //zj----hm----两种情况
        log.info("本次执行命令>>" + cmd);
        System.out.println(clientMessageTxt.toString());
        StringBuilder echoResultSb = new StringBuilder();
        // 校验后边再做；
        //现在加一个判断  分为  hm和 zj
       if(codHead.equals("zj")){
           return receivePackageSerivce.handleEartagData(clientMessageArray).toString();
       }

        if (Integer.parseInt(cmd) == 1) {
            // 绑定序列号返回的设备id
            return sendPackageService.getDeviceId(clientMessageArray);
        } else if (Integer.parseInt(cmd) == 2) {
            // 处理获取服务器时间
            return sendPackageService.getServerDateTime(clientMessageArray);
        } else if (Integer.parseInt(cmd) == 3) {
            // 处理心跳包
            return sendPackageService.getHeartbeatBag(clientMessageArray);
        } else if (Integer.parseInt(cmd) == 4) {
            // 处理温度上传
            return receivePackageSerivce.handleEartagTemperature(clientMessageArray);
        } else if (Integer.parseInt(cmd) == 5) {
            // 处理湿度上传
            return receivePackageSerivce.handleEartagDampness(clientMessageArray);
        } /*else if (Integer.parseInt(cmd) == 6) {     //不会出现等于6了。数据到此为止，为6的换成了zj
            // 处理耳标数据
            System.out.println("处理耳标数据");
            System.out.println(clientMessageTxt);
            return receivePackageSerivce.handleEartagData(clientMessageArray).toString();
       }*/
        else {
            log.error("出错：当前命令cmd>>[" + cmd + "]未做任何处理.");
            return  "null";
        }
        }
    }


