 package com.huimv.manager.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

import com.huimv.manager.entity.BaseFarmInfoEntity;
import com.huimv.manager.result.R;
import com.huimv.manager.service.BaseFarmInfoService;
import com.huimv.manager.utils.PageUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


 /**
  *
  *
  * @author yinhao
  * @version ${version}
  * @date 2021-07-27 14:50:11
  */
@RestController
@RequestMapping("management/basefarminfo")
@CrossOrigin
public class BaseFarmInfoController {
    @Autowired
    private BaseFarmInfoService baseFarmInfoService;

    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = baseFarmInfoService.queryPage(params);

        return R.ok().put("page", page);
    }


     /**
      * 列表
      */
     @RequestMapping("/findByCityCode")
     public R findByCityCode(@RequestParam Map<String, Object> params){
         List list = baseFarmInfoService.findByCityCode(params);

         return R.ok().put("page", list);
     }

    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		BaseFarmInfoEntity baseFarmInfo = baseFarmInfoService.getById(id);

        return R.ok().put("baseFarmInfo", baseFarmInfo);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody BaseFarmInfoEntity baseFarmInfo){
		baseFarmInfoService.save(baseFarmInfo);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody BaseFarmInfoEntity baseFarmInfo){
		baseFarmInfoService.updateById(baseFarmInfo);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		baseFarmInfoService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }
    @RequestMapping("/findAll")
    public R findAll(){

        return R.ok().put("data",baseFarmInfoService.list());
    }


}
