 package com.huimv.manager.controller;

import java.util.*;

import com.huimv.manager.result.R;
import com.huimv.manager.utils.PageUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.huimv.manager.entity.BasePigpenEntity;
import com.huimv.manager.service.BasePigpenService;



/**
 * 栋舍表
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-07-24 16:29:33
 */
@RestController
@RequestMapping("manager/basepigpen")
@CrossOrigin
public class BasePigpenController {
    @Autowired
    private BasePigpenService basePigpenService;

    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = basePigpenService.queryPage(params);

        return R.ok().put("page", page);
    }


    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		BasePigpenEntity basePigpen = basePigpenService.getById(id);

        return R.ok().put("basePigpen", basePigpen);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody BasePigpenEntity basePigpen){
		basePigpenService.save(basePigpen);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody BasePigpenEntity basePigpen){
		basePigpenService.updateById(basePigpen);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		basePigpenService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }

    @RequestMapping("/listAll")
    public R countAll(){
        List endList = new ArrayList();
        List<BasePigpenEntity> list = basePigpenService.list();
        for (BasePigpenEntity basePigpenEntity : list) {
            if (basePigpenEntity.getParentId() ==null){
                Map map =new HashMap();
                map.put("id",basePigpenEntity.getId());
                map.put("farmCode",basePigpenEntity.getFarmCode());
                map.put("parentId",basePigpenEntity.getParentId());
                map.put("pigpenName",basePigpenEntity.getPigpenName());
                map.put("type",basePigpenEntity.getType());
                map.put("children",getChildren(basePigpenEntity.getId(),list));
                endList.add(map);
            }

        }
        return R.ok().put("page", endList);
    }

    private List getChildren(Integer id, List<BasePigpenEntity> list) {
        List endList = new ArrayList();
        for (BasePigpenEntity basePigpenEntity : list) {
            if (id.equals( basePigpenEntity.getParentId())){
                Map map =new HashMap();
                map.put("id",basePigpenEntity.getId());
                map.put("farmCode",basePigpenEntity.getFarmCode());
                map.put("parentId",basePigpenEntity.getParentId());
                map.put("pigpenName",basePigpenEntity.getPigpenName());
                map.put("type",basePigpenEntity.getType());
                map.put("children",getChildren(basePigpenEntity.getId(),list));
                endList.add(map);
            }
        }
        return  endList;
    }


}
