 package com.huimv.manager.controller;

import java.util.Arrays;
import java.util.Map;

import com.huimv.manager.entity.BaseRegionEntity;
import com.huimv.manager.result.R;
import com.huimv.manager.service.BaseRegionService;
import com.huimv.manager.utils.PageUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;



/**
 * 
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-07-28 10:39:17
 */
@RestController
@RequestMapping("manager/baseregion")
public class BaseRegionController {
    @Autowired
    private BaseRegionService baseRegionService;

    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = baseRegionService.queryPage(params);

        return R.ok().put("page", page);
    }


    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		BaseRegionEntity baseRegion = baseRegionService.getById(id);

        return R.ok().put("baseRegion", baseRegion);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody BaseRegionEntity baseRegion){
		baseRegionService.save(baseRegion);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody BaseRegionEntity baseRegion){
		baseRegionService.updateById(baseRegion);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		baseRegionService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }


}
