 package com.huimv.manager.controller;

import java.util.Arrays;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.huimv.manager.entity.CompanyRegisterEntity;
import com.huimv.manager.service.CompanyRegisterService;
import com.huimv.manager.result.R;
import com.huimv.manager.utils.PageUtils;



/**
 * 第三方企业注册表
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-07-24 16:29:33
 */
@RestController
@RequestMapping("manager/companyregister")
@CrossOrigin
public class CompanyRegisterController {
    @Autowired
    private CompanyRegisterService companyRegisterService;

    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = companyRegisterService.queryPage(params);

        return R.ok().put("page", page);
    }


    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		CompanyRegisterEntity companyRegister = companyRegisterService.getById(id);

        return R.ok().put("companyRegister", companyRegister);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody CompanyRegisterEntity companyRegister){
		companyRegisterService.save(companyRegister);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody CompanyRegisterEntity companyRegister){
		companyRegisterService.updateById(companyRegister);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		companyRegisterService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }

}
