 package com.huimv.manager.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.*;

import com.huimv.manager.entity.EartagDataEntity;
import com.huimv.manager.service.EartagDataService;
import com.huimv.manager.result.R;
import com.huimv.manager.utils.PageUtils;



/**
 * 
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-07-24 16:29:33
 */
@RestController
@RequestMapping("manager/eartagdata")
@CrossOrigin
public class EartagDataController {
    @Autowired
    private EartagDataService eartagDataService;

    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = eartagDataService.queryPage(params);

        return R.ok().put("page", page);
    }


    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		EartagDataEntity eartagData = eartagDataService.getById(id);

        return R.ok().put("eartagData", eartagData);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody EartagDataEntity eartagData){
		eartagDataService.save(eartagData);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody EartagDataEntity eartagData){
		eartagDataService.updateById(eartagData);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		eartagDataService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }

    /**
     * 查询每小时的上传量
     */
    @RequestMapping("/countByTime")
    public R countByTime(@RequestParam Map<String, Object> params){
        Map list =  eartagDataService.countByTime(params);

        return R.ok().put("data",list);
    }

    /**
     * 查询每小时的上传量
     */
    @RequestMapping("/countByDay")
    public R countByDay(@RequestParam Map<String, Object> params){
        Map list =  eartagDataService.countByDay(params);

        return R.ok().put("data",list);
    }

    /*
    * 获取每日数据统计
    */
//    @Scheduled(cron = "1 1 * * * ?")
    @RequestMapping("/test")
    private void updateDailyData(){
        eartagDataService.updateDailyData();
    }




}
