 package com.huimv.manager.controller;

import java.util.Arrays;
import java.util.Map;

import com.huimv.manager.entity.EartagOffineEntity;
import com.huimv.manager.result.R;
import com.huimv.manager.service.EartagOffineService;
import com.huimv.manager.utils.PageUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;





/**
 * 
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-07-27 14:50:11
 */
@RestController
@RequestMapping("manager/eartagoffine")
public class EartagOffineController {
    @Autowired
    private EartagOffineService eartagOffineService;

    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = eartagOffineService.queryPage(params);

        return R.ok().put("page", page);
    }


    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		EartagOffineEntity eartagOffine = eartagOffineService.getById(id);

        return R.ok().put("eartagOffine", eartagOffine);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody EartagOffineEntity eartagOffine){
		eartagOffineService.save(eartagOffine);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody EartagOffineEntity eartagOffine){
		eartagOffineService.updateById(eartagOffine);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		eartagOffineService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }

}
