 package com.huimv.manager.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.huimv.manager.entity.EnvironmentDataEntity;
import com.huimv.manager.service.EnvironmentDataService;
import com.huimv.manager.result.R;
import com.huimv.manager.utils.PageUtils;



/**
 * 环境数据表
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-07-24 16:29:33
 */
@RestController
@RequestMapping("manager/environmentdata")
@CrossOrigin
public class EnvironmentDataController {
    @Autowired
    private EnvironmentDataService environmentDataService;

    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = environmentDataService.queryPage(params);

        return R.ok().put("page", page);
    }

    @RequestMapping("/countEnvironmentTemperature")
    public R findAll(@RequestParam Map<String, Object> params){
        List list = environmentDataService.countEnvironmentTemperature(params);

        return R.ok().put("page", list);
    }

    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		EnvironmentDataEntity environmentData = environmentDataService.getById(id);

        return R.ok().put("environmentData", environmentData);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody EnvironmentDataEntity environmentData){
		environmentDataService.save(environmentData);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody EnvironmentDataEntity environmentData){
		environmentDataService.updateById(environmentData);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		environmentDataService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }

}
