 package com.huimv.manager.controller;

import java.util.*;

import com.huimv.manager.entity.BasePigpenEntity;
import com.huimv.manager.entity.FarmStockEntity;
import com.huimv.manager.result.R;
import com.huimv.manager.service.FarmStockService;
import com.huimv.manager.utils.PageUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.*;


 /**
  *
  *
  * @author yinhao
  * @version ${version}
  * @date 2021-07-28 10:39:17
  */
@RestController
@RequestMapping("manager/farmstock")
@CrossOrigin
public class FarmStockController {
    @Autowired
    private FarmStockService farmStockService;

    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = farmStockService.queryPage(params);

        return R.ok().put("page", page);
    }

    /**
     * 全部
     */
    @RequestMapping("/countAll")
    public R countAll(@RequestParam Map<String, Object> params){
        List list = farmStockService.countAll(params);
        return R.ok().put("page", list);
    }

     /**
      * 市全部
      */
     @RequestMapping("/cityCountAll")
     public R cityCountAll(@RequestParam Map<String, Object> params){
         List list = farmStockService.cityCountAll(params);
         return R.ok().put("page", list);
     }


     /*
     * 定时更新regionStockDay表
     */
     @Scheduled(cron = "1 10 * * * ?")
    public void updateRegionStockDay(){
         farmStockService.updateRegionStockDay();

    }

    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		FarmStockEntity farmStock = farmStockService.getById(id);

        return R.ok().put("farmStock", farmStock);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody FarmStockEntity farmStock){
		farmStockService.save(farmStock);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody FarmStockEntity farmStock){
		farmStockService.updateById(farmStock);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		farmStockService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }

}
