 package com.huimv.manager.controller;

import java.util.Arrays;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.huimv.manager.entity.InterfaceRegisterEntity;
import com.huimv.manager.service.InterfaceRegisterService;
import com.huimv.manager.result.R;
import com.huimv.manager.utils.PageUtils;



/**
 * 推送接口表
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-07-24 16:29:33
 */
@RestController
@RequestMapping("manager/interfaceregister")
@CrossOrigin
public class InterfaceRegisterController {
    @Autowired
    private InterfaceRegisterService interfaceRegisterService;

    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = interfaceRegisterService.queryPage(params);

        return R.ok().put("page", page);
    }


    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		InterfaceRegisterEntity interfaceRegister = interfaceRegisterService.getById(id);

        return R.ok().put("interfaceRegister", interfaceRegister);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody InterfaceRegisterEntity interfaceRegister){
		interfaceRegisterService.save(interfaceRegister);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody InterfaceRegisterEntity interfaceRegister){
		interfaceRegisterService.updateById(interfaceRegister);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		interfaceRegisterService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }

}
