 package com.huimv.manager.controller;

import java.util.Arrays;
import java.util.Map;

import com.huimv.manager.entity.RegionStockDayEntity;
import com.huimv.manager.result.R;
import com.huimv.manager.service.RegionStockDayService;
import com.huimv.manager.utils.PageUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;





/**
 * 
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-08-05 18:46:23
 */
@RestController
@RequestMapping("management/regionstockday")
public class RegionStockDayController {
    @Autowired
    private RegionStockDayService regionStockDayService;

    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = regionStockDayService.queryPage(params);

        return R.ok().put("page", page);
    }


    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		RegionStockDayEntity regionStockDay = regionStockDayService.getById(id);

        return R.ok().put("regionStockDay", regionStockDay);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody RegionStockDayEntity regionStockDay){
		regionStockDayService.save(regionStockDay);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody RegionStockDayEntity regionStockDay){
		regionStockDayService.updateById(regionStockDay);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		regionStockDayService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }

}
