package com.huimv.manager.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

@Data
@TableName("collector_register")
public class CollectorRegisterEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 记录id(主键)
     */
    @TableId
    private Integer id;

    /**
     * 设备编码
     */
    private String deviceCode;

    /**
     * 盒子的芯片编码
     */
    private String registeCode;

    /**
     * 地县编码
     */
    private String countyCode;

    /**
     * 区县名
     */
    private String countyName;

    /**
     * 牧场编码
     */
    private String farmCode;

    /**
     * 牧场名称
     */
    private String farmName;

    /**
     * 动物种类
     */
    private Integer typeF;

    /**
     * 阶段
     */
    private Integer stage;

    /**
     * 猪舍id
     */
    private Integer pigpenId;

    /**
     * 单元id
     */
    private Integer unitId;

    /**
     * 上传服务器地址
     */
    private String serverIp;

    /**
     * 端口
     */
    private Integer port;

    /**
     * 注册时间
     */
    private Date registerTime;

    /**
     * 最后上传时间
     */
    private Date lastTime;

    /**
     * 采集状态 默认值 1  1.正常 0.异常
     */
    private Integer acqStatus;

    /**
     * 网络通信状态 默认值 1  1.正常 0.异常
     */
    private Integer networkStatus;

    /**
     * 注销状态 默认值 1  1.正常 0.注销
     */
    private Integer canStatus;

    /**
     * 删除状态 默认值 1  1.正常 0.注销
     */
    @TableLogic(delval = "0",value = "1")
    private Integer delStatus;

}
