package com.huimv.manager.mapper;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.huimv.manager.entity.BaseFarmInfoEntity;
import com.huimv.manager.entity.DailyTabulateDataEntity;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.huimv.manager.entity.vo.DailySowVo;
import com.huimv.manager.entity.vo.DayStockVo;
import com.huimv.manager.entity.vo.SunAreaStockVo;
import com.huimv.manager.entity.vo.DailyVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 耳标每日汇总表
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-07-24 16:29:33
 */
@Mapper
@Repository
public interface DailyTabulateDataDao extends BaseMapper<DailyTabulateDataEntity> {

    List<DayStockVo> getDayStockByRegion(@Param(Constants.WRAPPER) QueryWrapper<DayStockVo> query,@Param("type") Integer type);

    List<SunAreaStockVo> getCityPigStock(@Param(Constants.WRAPPER) QueryWrapper<SunAreaStockVo> sunAreaQuery,@Param("type") String type);

    List<DayStockVo> getMunicipalDayStock(@Param(Constants.WRAPPER) QueryWrapper<DayStockVo> query);

    List<DailyVo> selectDay(@Param(Constants.WRAPPER) QueryWrapper<DailyTabulateDataEntity> wrapper);

    List<DailyVo> selectMonth(@Param(Constants.WRAPPER) QueryWrapper<DailyTabulateDataEntity> wrapper);

    List<DailyVo> selectYear(@Param(Constants.WRAPPER) QueryWrapper<DailyTabulateDataEntity> wrapper);

    DailySowVo counSowAll(@Param(Constants.WRAPPER) QueryWrapper<DailyTabulateDataEntity> wrapper);
}
