package com.huimv.manager.service.impl;

import com.huimv.manager.entity.BaseFarmInfoEntity;
import com.huimv.manager.mapper.BaseFarmInfoDao;
import com.huimv.manager.service.BaseFarmInfoService;
import com.huimv.manager.utils.PageUtils;
import com.huimv.manager.utils.Query;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;


/**
 * 
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-07-27 14:50:11
 */
@Service("baseFarmInfoService")
public class BaseFarmInfoServiceImpl extends ServiceImpl<BaseFarmInfoDao, BaseFarmInfoEntity> implements BaseFarmInfoService {


    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<BaseFarmInfoEntity> page = this.page(
                new Query<BaseFarmInfoEntity>().getPage(params),
                new QueryWrapper<BaseFarmInfoEntity>()
        );

        return new PageUtils(page);
    }

    @Override
    public List findByCityCode(Map<String, Object> params) {

        String countyCode = (String)params.get("countyCode");
        if ("330000".equals(countyCode)){
            countyCode = null;
        }
        QueryWrapper<BaseFarmInfoEntity> wrapper = new QueryWrapper<>();
        wrapper.eq(StringUtils.isNotBlank(countyCode),"county",countyCode).or().eq(StringUtils.isNotBlank(countyCode),"city",countyCode);
       return baseMapper.selectList(wrapper);
    }
}