package com.huimv.manager.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.huimv.manager.entity.vo.EnvironmentDataVo;
import com.huimv.manager.mapper.EnvironmentDataDao;
import com.huimv.manager.result.RRException;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.manager.utils.PageUtils;
import com.huimv.manager.utils.Query;

import com.huimv.manager.entity.EnvironmentDataEntity;
import com.huimv.manager.service.EnvironmentDataService;

/**
 * 环境数据表
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-07-24 16:29:33
 */
@Service("environmentDataService")
public class EnvironmentDataServiceImpl extends ServiceImpl<EnvironmentDataDao, EnvironmentDataEntity> implements EnvironmentDataService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<EnvironmentDataEntity> page = this.page(
                new Query<EnvironmentDataEntity>().getPage(params),
                new QueryWrapper<EnvironmentDataEntity>()
        );

        return new PageUtils(page);
    }

    @Override
    public List countEnvironmentTemperature(Map<String, Object> params) {
//        String farmCode = (String) params.get("farmCode");
//        if (org.apache.commons.lang.StringUtils.isBlank(farmCode)){
//            throw new RRException("牧场未选择");
//        }
        String startTime = (String) params.get("startTime");
        String endTime = (String) params.get("endTime");
        String deviceCode = (String) params.get("deviceCode");

        QueryWrapper<EnvironmentDataEntity> wrapper = new QueryWrapper<>();
//        wrapper.eq(StringUtils.isNotBlank(farmCode),"farm_code",farmCode);
        wrapper.eq(StringUtils.isNotBlank(deviceCode),"device_code",deviceCode);
        wrapper.ge(StringUtils.isNotBlank(startTime),"acq_date",startTime);
        wrapper.le(StringUtils.isNotBlank(endTime),"acq_date",endTime);


       wrapper.groupBy("acq");
//        List<EnvironmentDataEntity> environmentDataEntities = baseMapper.selectList(wrapper);
        List<EnvironmentDataVo> list = baseMapper.countEnvironmentTemperature(wrapper);


        return list;
    }
}