package com.huimv.manager.service.impl;

import com.huimv.manager.entity.StockOutEntity;
import com.huimv.manager.mapper.StockOutDao;
import com.huimv.manager.service.StockOutService;
import com.huimv.manager.utils.PageUtils;
import com.huimv.manager.utils.Query;
import org.apache.commons.lang.StringUtils;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;


/**
 * 
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-08-06 15:40:07
 */
@Service("stockOutService")
public class StockOutServiceImpl extends ServiceImpl<StockOutDao, StockOutEntity> implements StockOutService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<StockOutEntity> page = this.page(
                new Query<StockOutEntity>().getPage(params),
                new QueryWrapper<StockOutEntity>()
        );

        return new PageUtils(page);
    }

    @Override
    public List findByCode(Map<String, Object> params) {
        String farmCode = (String)params.get("farmCode");
        QueryWrapper<StockOutEntity> stockOutEntityQueryWrapper = new QueryWrapper<>();
        if (StringUtils.isBlank(farmCode)) {
            List list = new ArrayList();
           StockOutEntity stockOutEntity = baseMapper.counAll();
            list.add(stockOutEntity);
           return list;
        }

        stockOutEntityQueryWrapper.eq(StringUtils.isNotBlank(farmCode),"region_code",farmCode);

        List<StockOutEntity> stockOutEntities = baseMapper.selectList(stockOutEntityQueryWrapper);
        return stockOutEntities;
    }

}