package com.huimv.manager;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.huimv.manager.entity.dto.DataAnalysisDto;
import com.huimv.manager.entity.vo.DayStockVo;
import com.huimv.manager.entity.vo.SunAreaStockVo;
import com.huimv.manager.mapper.BasePigpenMapper;
import com.huimv.manager.mapper.BaseRegionDao;
import com.huimv.manager.mapper.DailyTabulateDataDao;
import com.huimv.manager.utils.Constant;
import org.apache.commons.lang.StringUtils;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.List;

/**
 * <p>
 *
 * </p>
 *
 * @author yinhao
 * @date 2021/7/24 14:20
 */
@SpringBootTest
public class HuimvSmartEartagDataManagerTests {

    @Autowired
    private BasePigpenMapper basePigpenMapper;

    @Autowired
    private BaseRegionDao baseRegionDao;

    @Autowired
    private DailyTabulateDataDao dailyTabulateDataDao;

    @Test
    void contextLoads() {
//        List<BasePigpenEntity> basePigpenEntities = basePigpenMapper.selectList(null);
//        System.out.println(basePigpenEntities);


//        List<BaseRegionEntity> all = baseRegionDao.selectList(Wrappers.<BaseRegionEntity>lambdaQuery().eq(BaseRegionEntity::getParentCode, "001"));
//        all.stream().filter()

        DataAnalysisDto dataAnalysisDto = new DataAnalysisDto();
        dataAnalysisDto.setRegionCode("001");
        String start = dataAnalysisDto.getStart();
        if (StringUtils.isEmpty(start)) {
            start = DateUtil.format(DateUtil.offsetMonth(DateUtil.date(), -1), "yyyy-MM-dd");
        }
        String end = dataAnalysisDto.getEnd();
        if (StringUtils.isEmpty(end)) {
            end = DateUtil.format(DateUtil.date(), "yyyy-MM-dd");
        }

//        List<DayStockVo> dayStockVoList =  dailyTabulateDataDao.getDayStockByRegion(query);
//        System.out.println(dayStockVoList);


        QueryWrapper<SunAreaStockVo> sunAreaQuery = Wrappers.query();
        sunAreaQuery.eq("farm.province", dataAnalysisDto.getRegionCode())
                .ge("dtd.statistic_date", start)
                .le("dtd.statistic_date", end)
                .groupBy("farm.city", "dtd.statistic_date")
                .orderByDesc("dtd.statistic_date");
//        List<SunAreaStockVo> sunAreaStockVoList = dailyTabulateDataDao.getCityPigStock(sunAreaQuery);

//        System.out.println(sunAreaStockVoList);

    }

    @Test
    void testdata() {
        DataAnalysisDto dataAnalysisDto = new DataAnalysisDto();
        dataAnalysisDto.setRegionCode("002");
        QueryWrapper<DayStockVo> query = Wrappers.query();
        String start = dataAnalysisDto.getStart();
        DateTime nowDate = DateUtil.date();
        if (StringUtils.isEmpty(start)) {
            start = DateUtil.format(DateUtil.offsetMonth(nowDate, -12), Constant.DATE_FORMAT_YM) + "-01";
        } else {
            start += "-01";
        }
        String end = dataAnalysisDto.getEnd();
        if (StringUtils.isEmpty(end) || end.equals(DateUtil.format(nowDate, Constant.DATE_FORMAT_YM))) {
            end = DateUtil.format(nowDate, Constant.DATE_FORMAT_YMD);
        } else {
            end = DateUtil.format(DateUtil.endOfMonth(DateUtil.parse(end, Constant.DATE_FORMAT_YM)),Constant.DATE_FORMAT_YMD);
        }

        query.eq("farm.city", dataAnalysisDto.getRegionCode())
                .ge("dtd.statistic_date", start)
                .le("dtd.statistic_date", end)
                .groupBy("farm.city", "DATE_FORMAT(dtd.statistic_date,'%Y-%m')")
                .orderByAsc("date");

        List<DayStockVo> dayStockVoList = dailyTabulateDataDao.getMunicipalDayStock(query);
        System.out.println(dayStockVoList);
    }
}
