package com.huimv.transmission.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.sql.Date;

/**
 * 耳标每日汇总表
 */
@Data
@TableName("daily_tabulate_data")
public class DailyTabulateDataEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId
    private Integer id;

    /**
     * 统计日期
     */
    private Date statisticDate;

    /**
     * 当日母猪总存栏
     */
    private Integer stockTotal;

    /**
     * 每日母猪新增耳标数
     */
    private Integer stockNew;

    /**
     * 每日离线耳标数
     */
    private Integer offlineNo;

    /**
     * 日龄占比（250-1000）
     */
    private Double ratio1;

    /**
     * 日龄（1000-1700）
     */
    private Double ratio2;

    /**
     * 日龄（1700-2400）
     */
    private Double ratio3;

    /**
     * 日龄（>2400)
     */
    private Double ratio4;

    /**
     * 配怀存栏
     */
    private Integer stock1;

    /**
     * 分娩存栏
     */
    private Integer stock2;

    /**
     * 后备存栏
     */
    private Integer stock3;

    /**
     * 公猪存栏
     */
    private Integer stock4;

    /**
     * 牧场编码
     */
    private String farmCode;

}
