package com.huimv.transmission.entity.form;

import cn.hutool.core.date.DateUtil;
import com.huimv.transmission.utils.Constant;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

/**
 * <p>
 *
 * </p>
 *
 * @author yinhao
 * @date 2021/7/27 20:16
 */
@Data
public class BaseForm {

    @NotBlank(message = "accessToken不能为空!")
    protected String accessToken;

    @NotBlank(message = "serviceNo不能为空!")
    protected String serviceNo;

    protected Integer pageNo = 1;

    protected Integer pageSize = 100;

    protected Date startDate;

    protected Date endDate;

    protected String farmID;

    public BaseForm() {
    }

    public BaseForm(Integer pageNo, Integer pageSize) {
        this.pageNo = pageNo;
        this.pageSize = pageSize;
    }

    public Date getEndDate() {
        if (endDate != null) {
            Date date = new Date();
            return Constant.SDF_YMD.format(endDate).equals(Constant.SDF_YMD.format(date)) ? date : DateUtil.offsetDay(endDate, 1);
        }
        return null;
    }
}
