package com.huimv.transmission.entity.vo;

import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 耳标具体信息vo
 * </p>
 *
 * @author yinhao
 * @date 2021/7/30 9:52
 */
@Data
@JsonPropertyOrder({"farmID","time","eartagNo","firstTime","dayAge","dayAge2","earTemp","envTemp","exercise","bat","rssi","stage","pigpen","deviceCode"})
public class EartagDetailVo implements Serializable {
    private static final long serialVersionUID = 6647833319738689903L;

    /**
     * 牧场编码
     */
    private String farmID;
    /**
     * 采集时间
     */
    private Date time;
    /**
     * 耳标号
     */
    @JsonProperty("eartag_no")
    private String eartagNo;
    /**
     * 配标时间
     */
    @JsonProperty("first_time")
    private Date firstTime;
    /**
     * 配标日龄
     */
    @JsonProperty("day_age")
    private Integer dayAge;
    /**
     * 日龄
     */
    @JsonProperty("day_age2")
    private Integer dayAge2;
    /**
     * 耳根温度
     */
    @JsonProperty("ear_temp")
    private Double earTemp;
    /**
     * 环境温度
     */
    @JsonProperty("env_temp")
    private Double envTemp;
    /**
     * 运动量
     */
    private Integer exercise;
    /**
     * 电池电量
     */
    private Integer bat;
    /**
     * 信号强度
     */
    private Integer rssi;
    /**
     * 阶段
     */
    private Integer stage;
    /**
     * 栋舍
     */
    private String pigpen;
    /**
     * 采集器编码
     */
    @JsonProperty("device_code")
    private String deviceCode;


}
