package com.huimv.transmission.mapper;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.huimv.transmission.entity.EartagDataEntity;
import com.huimv.transmission.entity.NewAndOffLineEartagEntity;
import com.huimv.transmission.entity.vo.EartagDataVo;
import com.huimv.transmission.entity.vo.EartagDetailVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * @author yinhao
 * @version ${version}
 * @date 2021-07-24 16:29:33
 */
@Mapper
@Repository
public interface EartagDataDao extends BaseMapper<EartagDataEntity> {

    List<NewAndOffLineEartagEntity> selectNowDayChangeEartagList();

    IPage<NewAndOffLineEartagEntity> selectChangeEartagList(@Param("page") IPage page, @Param("startDate") Date startDate, @Param("endDate") Date endDate, @Param("farmCode") String farmCode, @Param("stage") Integer stage);

    IPage<EartagDataVo> selectByConditions(@Param("page") IPage<EartagDataVo> ipage, @Param(Constants.WRAPPER) LambdaQueryWrapper<EartagDataEntity> lambdaQuery);

    IPage<EartagDetailVo> selectEartagDetails(@Param("page") IPage<EartagDetailVo> iPage, @Param(Constants.WRAPPER) QueryWrapper<EartagDetailVo> query);
}
