package com.huimv.transmission.mapper;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.huimv.transmission.entity.FarmEartagChangeEntity;
import com.huimv.transmission.entity.vo.ChangeEartagDataVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Update;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.HashSet;
import java.util.List;

/**
 * <p>
 *
 * </p>
 *
 * @author yinhao
 * @date 2021/7/26 17:47
 */
@Mapper
@Repository
public interface FarmEartagChangeDao extends BaseMapper<FarmEartagChangeEntity> {

    IPage<ChangeEartagDataVo> getPigStockByChangeType(@Param("page") IPage<ChangeEartagDataVo> iPage, @Param(Constants.WRAPPER) LambdaQueryWrapper<FarmEartagChangeEntity> lambdaQuery);

    List<String> getEartags(Integer type);

    void batchInsertNewEartags(@Param("farmCode") String farmCode,@Param("changeType") Integer changeType, @Param("todaySet") HashSet<String> todaySet);

    @Update("truncate table farm_eartag_change")
    void truncateTable();
}
