package com.huimv.transmission.result;


import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;

public class R extends LinkedHashMap<String, Object> {

    private static final long serialVersionUID = 1L;

    public R() {
        put("resultCode", 10000);
        put("resultMsg", "查询成功");
    }

    public static R error() {
        return error(10001, "未知异常，请联系管理员");
    }

    public static R error(String msg) {
        return error(10001, msg);
    }

    public static R error(int code, String msg) {
        R r = new R();
        r.put("resultCode", code);
        r.put("resultMsg", msg);
        return r;
    }

    public static R ok(String msg) {
        R r = new R();
        r.put("resultMsg", msg);
        return r;
    }

    public static R ok(Map<String, Object> map) {
        R r = new R();
        r.putAll(map);
        return r;
    }

    public static R ok() {
        return new R();
    }

    @Override
    public R put(String key, Object value) {
        super.put(key, value);
        return this;
    }

    public static void main(String[] args) {
        R r = new R();
        System.out.println(r);

    }
}