package com.huimv.transmission.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.huimv.transmission.entity.form.PigStockForm;
import com.huimv.transmission.entity.vo.DailyTabulateDataVo;
import com.huimv.transmission.entity.vo.ChangeEartagDataVo;
import com.huimv.transmission.service.DailyTabulateDataService;
import com.huimv.transmission.service.DataPushService;
import com.huimv.transmission.service.FarmEartagChangeService;
import com.huimv.transmission.utils.PageUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 *
 * </p>
 *
 * @author yinhao
 * @date 2021/7/26 10:24
 */
@Service("dataPushService")
public class DataPushServiceImpl implements DataPushService {

    @Autowired
    private DailyTabulateDataService dailyTabulateDataService;

    @Autowired
    private FarmEartagChangeService farmEartagChangeService;

    @Override
    public PageUtils getPigStock(PigStockForm pigStockForm) {
        IPage<DailyTabulateDataVo> page = dailyTabulateDataService.getPigStockPage(pigStockForm);
        return new PageUtils(page);
    }

    @Override
    public PageUtils getNewPigStock(Integer currPage, Integer pageSize) {
        return getPigStockByChangeType(currPage, currPage, 1);
    }

    @Override
    public PageUtils getOffLinePigStock(Integer currPage, Integer pageSize) {
        return getPigStockByChangeType(currPage, pageSize, 2);
    }

    private PageUtils getPigStockByChangeType(Integer currPage, Integer pageSize, Integer type) {
        IPage<ChangeEartagDataVo> page = farmEartagChangeService.getPigStockByChangeType(currPage, pageSize, type);
        return new PageUtils(page);
    }
}
