package com.huimv.transmission;


import com.alibaba.fastjson.JSONObject;
import com.huimv.transmission.result.R;
import com.huimv.transmission.service.DataPushService;
import com.huimv.transmission.service.EartagDataService;
import com.huimv.transmission.utils.PageUtils;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.IOException;
import java.nio.charset.Charset;

/**
 * <p>
 *
 * </p>
 *
 * @author yinhao
 * @date 2021/7/27 13:24
 */
@SpringBootTest
public class HuimvSmartEartagDataManagerTest {

    @Autowired
    private DataPushService dataPushService;

    @Autowired
    private EartagDataService eartagDataService;

    @Test
    void contextLoads() throws IOException {
//        PageUtils page = dataPushService.getPigStock(1,1000);
//        HttpPost httpPost = new HttpPost("http://127.0.0.1:8220/dataPush/recive");
//        httpPost.addHeader("Content-Type", "application/json");
//        R resultData = R.ok().put("resultData", page);
//        String string = JSONObject.toJSONString(resultData).replace("newCount","new");
//        System.out.println(string);
//        httpPost.setEntity(new StringEntity(string, Charset.defaultCharset()));
//        CloseableHttpClient httpClient = HttpClients.createDefault();
//        httpClient.execute(httpPost);
//        httpClient.close();
//        eartagDataService.handleNewAndOffLineEartag();

        CloseableHttpClient httpClient = null;
        try {
            HttpPost httpPost = new HttpPost("http://127.0.0.1:8220/pig/recive");
            httpPost.addHeader("Content-Type", "application/json");
            httpClient = HttpClients.createDefault();

            eartagDataService.handleNewAndOffLineEartag();

            PageUtils page = dataPushService.getOffLinePigStock(1, 1000);
            handleDataAndPush(page, httpPost, httpClient,2);

            int pageSize = page.getPageSize();
            int totalPage = page.getTotalPage();
            for (int i = 2; i <= totalPage; i++) {
                PageUtils pigStock = dataPushService.getOffLinePigStock(i, pageSize);
                handleDataAndPush(pigStock, httpPost, httpClient,2);
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (httpClient != null) {
                    httpClient.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }


    private void handleDataAndPush(PageUtils page, HttpPost httpPost, CloseableHttpClient httpClient, Integer type) throws IOException {
        R resultData = R.ok().put("resultData", page);
        String string = null;
        if (type == 2) {
            string = JSONObject.toJSONString(resultData).replace("new", "eliminate");
        } else {
            string = JSONObject.toJSONString(resultData);
        }
        System.out.println(string);
        httpPost.setEntity(new StringEntity(string, Charset.defaultCharset()));
        httpClient.execute(httpPost);
    }
}
